<script setup lang="ts">
import { ref, onMounted, watch } from "vue";
import { useQuasar } from "quasar";

import http from "@/plugins/http";
import config from "@/app.config";
import { tokenParsed } from "@/plugins/auth";
import { useCounterMixin } from "@/stores/mixin";
import { useLeaveStore } from "@/modules/05_leave/store";

import FullCalendar from "@fullcalendar/vue3";
import dayGridPlugin from "@fullcalendar/daygrid";
import timeGridPlugin from "@fullcalendar/timegrid";
import interactionPlugin from "@fullcalendar/interaction";
import allLocales from "@fullcalendar/core/locales-all";
import listPlugin from "@fullcalendar/list";

import type { DataDateMonthObject } from "@/modules/05_leave/interface/request/Calendar.ts";
import type {
  DataCalendar,
  LeaveType,
} from "@/modules/05_leave/interface/response/leave";

import DialogDetail from "@/modules/05_leave/components/DialogDetail.vue";

const $q = useQuasar();
const store = useLeaveStore();
const mixin = useCounterMixin();
const { messageError, monthYear2Thai } = mixin;
const emit = defineEmits(["update:dateYear"]);

const mainData = ref<DataCalendar[]>([]);
const keycloakId = ref<string>("");
const modal = ref<boolean>(false);
const leaveId = ref<string>("");

/** filter calendar left */
const filterLists = ref<any>([]);
const filterVal = ref<any>([keycloakId.value]);
const isLoading = ref<boolean>(false);
const isLoadingHoliday = ref<boolean>(false);

/** Option ของปฏิทิน */
const fullCalendar = ref<any>(); //ref calendar
const calendarOptions = ref<any>({
  plugins: [
    dayGridPlugin,
    timeGridPlugin,
    interactionPlugin, // needed for dateClick
    listPlugin,
  ],
  headerToolbar: false,
  initialView: "dayGridMonth",
  initialEvents: [], // alternatively, use the `events` setting to fetch from a feed
  selectable: true,
  dayMaxEvents: true,
  weekends: true,
  locale: "th",
  locales: allLocales,
  expandRows: true,
  nowIndicator: true,
  height: "100%",
  eventColor: "#4CAF4F",
  eventTextColor: "#fff",
  eventBorderColor: "#50a5fc",
  displayEventTime: false,
  editable: true,
  events: [],
});

/**Map ตัวแปร dateMonth */
const dateMonth = ref<DataDateMonthObject>({
  month: new Date().getMonth(),
  year: new Date().getFullYear(),
});

/** function เรียกข้อมูล calendar*/
async function fetchDataCalendar() {
  isLoading.value = true;
  await http
    .post(config.API.leaveCalendar(), {
      year: dateMonth.value.year,
    })
    .then((res) => {
      mainData.value = res.data.result;

      const double_name = [
        ...new Set(mainData.value.map((item: DataCalendar) => item.keycloakId)),
      ];
      filterLists.value = [];
      for (let i = 1; i <= double_name.length; i++) {
        const name = double_name[i - 1];
        const filterName = {
          id: name,
          name: convertKeycloakId(name),
          color: name === keycloakId.value ? "green" : "grey",
        };
        filterLists.value.push(filterName);
      }
      const eventData = filterVal.value.map((item: any) => {
        return mainData.value
          .filter(
            (e: DataCalendar) => e.keycloakId === item && e.status === "APPROVE"
          )
          .map((e) => ({
            id: e.id,
            title: `${e.fullName} (${e.leaveTypeName})`,
            start: e.leaveStartDate,
            end: new Date(
              new Date(e.leaveEndDate).setHours(23, 59, 59)
            ).toISOString(),
            allDay: e.leaveStartDate === e.leaveEndDate ? true : false,
            color: e.keycloakId === keycloakId.value ? "#DCEDC8" : "#CFD8DC",
            textColor: "black",
          }));
      });
      const allEventData = [].concat(...eventData);
      calendarOptions.value.events = allEventData;
      //   }
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      isLoading.value = false;
    });
}

/**
 * fetch วันหยุดในปฏิทิน
 */
async function fetchData() {
  isLoadingHoliday.value = true;
  await http
    .get(
      config.API.listHolidayHistoryYearMonth(
        dateMonth.value.year,
        dateMonth.value.month + 1
      )
    )
    .then((res) => {
      const dataNormal = res.data.result.normal;
      const data = dataNormal;
      const event = data.map((e: any) => ({
        id: e.id,
        title: `${e.name} `,
        start: e.holidayDate,
        end: new Date(
          new Date(e.holidayDate).setHours(23, 59, 59)
        ).toISOString(),
        allDay: e.holidayDate === e.holidayDate ? true : false,
        color: " #CCE5FF",
        textColor: "#0080FF",
      }));
      calendarOptions.value.events = [
        ...calendarOptions.value.events,
        ...event,
      ];
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      isLoadingHoliday.value = false;
    });
}

/**function แปลงkeycloakId */
function convertKeycloakId(id: any) {
  const filterName = mainData.value.find((e: any) => e.keycloakId === id);
  return filterName?.fullName;
}

/** function เรียกประเภทการลา */
const leaveType = ref<LeaveType[]>([]);
async function fectOptionType() {
  const data = await store.fetchLeaveTypeData();
  if (!data) {
    return;
  }
  leaveType.value = data;
}

/**
 * แปลง ปีและเดือนเป็นภาษาไทย
 * @param val datepicker แบบเลือกปีและเดือน
 */
function monthYearThai(val: DataDateMonthObject) {
  if (val == null) return "";
  else return monthYear2Thai(val.month, val.year);
}

/** function อัปเดท Calendar */
async function updateMonth() {
  try {
    await fetchDataCalendar();
    await fetchData();
    const calen = fullCalendar.value.getApi();
    const date = new Date(dateMonth.value.year, dateMonth.value.month);
    calen.gotoDate(date);
  } catch (error) {
    messageError($q, error);
  } finally {
  }
}

/**
 * function openPopupDateail
 * @param id การลา
 */
async function onCilckview(id: string) {
  modal.value = true;
  leaveId.value = id;
}

/** function closePopup*/
async function onClickClose() {
  modal.value = false;
}

/** ตรวจสอบว่ามีการส่งข้อมูลเข้ามาที่Calendar */
watch(
  () => filterVal.value,
  async () => {
    const eventData = filterVal.value.map((item: any) => {
      return mainData.value
        .filter(
          (e: DataCalendar) => e.keycloakId === item && e.status === "APPROVE"
        )
        .map((e) => ({
          id: e.id,
          title: `${e.fullName} (${e.leaveTypeName})`,
          start: e.leaveStartDate,
          end: new Date(
            new Date(e.leaveEndDate).setHours(23, 59, 59)
          ).toISOString(),
          allDay: e.leaveStartDate === e.leaveEndDate ? true : false,
          color: e.keycloakId === keycloakId.value ? "#DCEDC8" : "#CFD8DC",
          textColor: "black",
        }));
    });
    const allEventData = [].concat(...eventData);
    calendarOptions.value.events = allEventData;
    await fetchData();
  }
);

/**Hook */
onMounted(async () => {
  try {
    isLoading.value = true;
    // เรียกข้อมูล keycloakId
    const user = await tokenParsed();
    keycloakId.value = await (user ? user.sub : "");
    filterVal.value.push(keycloakId.value);
    await Promise.all([fetchDataCalendar(), fectOptionType()]);
    await fetchData();
  } catch (error) {
    messageError($q, error);
  } finally {
    isLoading.value = false;
  }
});
</script>

<template>
  <div class="row">
    <div class="col-xs-12 col-md-3 q-mt-sm q-pr-sm row">
      <q-card class="col-12" flat bordered>
        <q-card-section v-if="isLoading">
          <q-item>
            <q-item-section avatar>
              <q-skeleton type="QToggle" height="20px" width="25px" />
            </q-item-section>

            <q-item-section>
              <q-skeleton type="text" class="text-subtitle1" />
            </q-item-section>
          </q-item>
        </q-card-section>

        <q-scroll-area style="height: 38vw" v-else>
          <div class="q-gutter-sm col-12">
            <q-list class="rounded-borders q-pt-sm" dense>
              <q-item
                v-for="(item, i) in filterLists"
                :key="i"
                tag="label"
                v-ripple
              >
                <q-checkbox
                  size="sm"
                  v-model="filterVal"
                  :val="item.id"
                  :color="item.color"
                />
                <q-item-section>
                  <q-item-label>{{ item.name }}</q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </div>
        </q-scroll-area>
      </q-card>
    </div>

    <div class="col-xs-12 col-md-9 row">
      <div class="q-mt-sm col-12">
        <div class="row col-12 q-gutter-sm">
          <div class="demo-app-main">
            <q-card
              bordered
              flat
              class="q-pa-sm q-mb-sm col-12 row bg-grey-1 shadow-0"
            >
              <div class="items-center col-12 row q-col-gutter-sm">
                <!-- filter เลือกเดือนปี -->
                <datepicker
                  v-model="dateMonth"
                  :locale="'th'"
                  autoApply
                  month-picker
                  :enableTimePicker="false"
                  @update:modelValue="updateMonth"
                >
                  <template #year="{ year }">{{ year + 543 }}</template>
                  <template #year-overlay-value="{ value }">{{
                    parseInt(value + 543)
                  }}</template>
                  <template #trigger>
                    <q-input
                      :model-value="monthYearThai(dateMonth)"
                      dense
                      outlined
                      bg-color="white"
                      style="width: 130px"
                    >
                      <template v-slot:prepend>
                        <q-icon
                          name="event"
                          class="cursor-pointer"
                          style="color: var(--q-primary)"
                        >
                        </q-icon>
                      </template>
                    </q-input>
                  </template>
                </datepicker>
              </div>
            </q-card>

            <div class="main-content">
              <q-skeleton
                height="100%"
                square
                v-if="isLoading || isLoadingHoliday"
              />
              <FullCalendar
                v-else
                ref="fullCalendar"
                class="demo-app-calendar"
                :options="calendarOptions"
              >
                <template v-slot:eventContent="arg">
                  <div
                    v-if="arg.event.textColor == 'black'"
                    class="row col-12 items-center no-wrap"
                    :style="`background: + ${arg.event.color}`"
                  >
                    <div
                      class="textHover col-10"
                      @click="onCilckview(arg.event.id)"
                    >
                      {{ arg.event.title }}
                    </div>
                  </div>
                  <div
                    v-else
                    class="row col-12 items-center no-wrap"
                    :style="`background: + ${arg.event.color}`"
                  >
                    <div class="textHover col-10">
                      {{ arg.event.title }}
                    </div>
                  </div>
                </template>
              </FullCalendar>
            </div>
          </div>
        </div>
        <div class="row q-col-gutter-lg justify-end">
          <div class="items-center row">
            <q-icon
              size="10px"
              color="blue"
              name="mdi-circle"
              class="q-mr-sm"
            />
            <span class="text-caption text-grey-8">วันหยุด</span>
          </div>
          <div class="items-center row">
            <q-icon
              size="10px"
              color="green-7"
              name="mdi-circle"
              class="q-mr-sm"
            />
            <span class="text-caption text-grey-8">การลาของฉัน</span>
          </div>
          <div class="items-center row">
            <q-icon
              size="10px"
              color="grey-6"
              name="mdi-circle"
              class="q-mr-sm"
            />
            <span class="text-caption text-grey-8">การลาของบุคคลอื่น</span>
          </div>
        </div>
      </div>
    </div>
  </div>

  <DialogDetail
    :modal="modal"
    :leaveId="leaveId"
    :onClickClose="onClickClose"
    :leaveType="leaveType"
  />
</template>

<style scope lang="scss">
.main-content {
  height: 70vh;
}

.padding-content {
  padding: 10px;
}

.demo-app-main {
  flex-grow: 1;
  /* padding: 3em; */
}

.fc {
  /* the calendar root */
  max-width: 1100px;
  margin: 0 auto;
  background-color: white;
  border-radius: 10px;
}

.fc-day-today {
  background-color: #f8f8f8 !important;
}

.fc-day-today .fc-daygrid-day-number {
  display: flex;
  justify-content: center;
  align-items: center;
  /* border: 2px solid #17a259; */
  /* border-radius: 50%;
  height: 25px;
  width: 25px;
  font-weight: bold;
  color: white !important;
  background: #17a259; */
}

.fc-day-today .fc-daygrid-day-frame {
  padding: 5%;
}

.fc .fc-button-group > .fc-button {
  color: black;
  background-color: #fafafa;
  border: none;
}

.fc .fc-button-group > .fc-button:active {
  color: white;
  background-color: #22a15e;
  border: none;
}

.fc .fc-button-group > .fc-button.fc-button-active {
  color: white;
  background-color: #22a15e;
  border: none;
}

.fc-header-toolbar {
  background-color: white;
  padding: 0px 10px 0px 10px;
  border-radius: 10px 10px 0px 0px;
}

.fc .fc-scrollgrid-liquid > thead {
  background-color: white;
}

.dp-custom-cell {
  border-radius: 50%;
}

.dp__today {
  border: 1px solid var(--q-primary);
}

.dp__range_end,
.dp__range_start,
.dp__active_date {
  background: var(--q-primary);
  color: var(--dp-primary-text-color);
}

.datepicker .q-field__label {
  padding-left: 5px;
}

.datepicker .q-field__messages {
  padding-left: 20px;
}

.datepicker .q-field__native {
  padding-left: 5px;
  color: var(--q-primary) !important;
}

.datepicker .q-field__prepend {
  padding-left: 6px;
}

.datepicker .q-field__append {
  padding-right: 6px;
}

.datepicker .q-field__after {
  display: flex;
  justify-content: flex-end;
  align-items: center;
  font-weight: 500;
}

.fc .fc-popover {
  z-index: 6000;
}

.fc-direction-ltr .fc-daygrid-event.fc-event-end,
.fc-direction-rtl .fc-daygrid-event.fc-event-start {
  cursor: pointer;
}

.subName {
  display: flex;
  justify-content: flex-end;
  align-items: center;
  font-weight: 500;
}

.subInput {
  display: flex;
  align-items: center;
}

.fc-event {
  overflow: hidden;
  border-color: transparent !important;
  font-weight: 500;
}

.fc-event-main {
  text-align: left;
  padding: 0px 5px;
}

.fc-direction-ltr .fc-daygrid-event.fc-event-end,
.fc-direction-rtl .fc-daygrid-event.fc-event-start {
  padding-left: 0px;
}

.fc-theme-standard td,
.fc-theme-standard th {
  border: 1px solid #ebe9f1;
}

.textHover:hover {
  color: var(--q-primary);
}
</style>
